> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://contentful.com/developers/docs/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://contentful.com/developers/docs/_mcp/server.

Similar to cross-space references that allow you to link content across multiple spaces, Native external references allow you to integrate content from external sources using the [Contentful App Framework](/extensibility/app-framework).

To resolve data from third-party systems, you have to include the `externalReferences=*` query parameter into your queries.

### Request

```
curl --location 'https://cdn.contentful.com/spaces/{space_id}/environments/{environment_id}/entries?externalReferences=*' \
     --header 'Authorization: Bearer <CDA Token>'
```

> **Info**
>
> For the CPA, the URL is `preview.contentful.com`, while for the CDA it is `cdn.contentful.com`.

### Parameters

| Parameter              | Description                                                                                          | Required |
| ---------------------- | ---------------------------------------------------------------------------------------------------- | -------- |
| `space_id`             | String. Alphanumeric ID of the space to retrieve.                                                    | Yes      |
| `environment_id`       | String. ID of the environment in form of a string.                                                   | Yes      |
| `access_token`         | String. A production Content Delivery API key.                                                       | Yes      |
| `externalReferences=*` | String. Query param required in CDA and CPA to make a request to resolve Native external references. | Yes      |

### Capabilities

Publishing new content in a space will cause the cache to be purged on every request that included that space ID, including external references.

### Errors

Errors from Native external reference function invocations are propagated back to the response payload in the `errors` property.

The following error occurs when there is no app installed to resolve the reference in the space or environment:

```json
{
            "urn": "gid://shopify/Product/7983602040854",
            "resourceType": "MyProvider:MyType",
            "error": "Resource type 'MyProvider:MyType', is not configured"
        }
```

### Limitations

* Up to `1000` references in the `includes` property in the response
* No [Advanced caching](/platform/advanced-caching) support
* No [MRDI](/platform/mrdi) support